Package org.eclipse.ecf.provider.zookeeper.core

## Class ZooDiscoveryContainerInstantiator

- java.lang.Object
- - org.eclipse.ecf.provider.zookeeper.core.ZooDiscoveryContainerInstantiator

All Implemented Interfaces:
  `IContainerInstantiator`

    public class ZooDiscoveryContainerInstantiator
    extends Object
    implements IContainerInstantiator

### Field Summary

Fields
`static String` `NAME`

### Constructor Summary

Constructors
`ZooDiscoveryContainerInstantiator()`

### Method Summary

All Methods Instance Methods Concrete Methods
`IContainer` `createInstance​(ContainerTypeDescription description, Object[] parameters)` Create instance of IContainer.
`String[]` `getSupportedAdapterTypes​(ContainerTypeDescription description)` Get array of supported adapters for the given container type description.
`String[]` `getSupportedIntents​(ContainerTypeDescription description)`
`Class[][]` `getSupportedParameterTypes​(ContainerTypeDescription description)` Get array of parameter types for given container type description.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### NAME

    public static final String NAME

See Also:
  Constant Field Values

### Constructor Detail

#### ZooDiscoveryContainerInstantiator

    public ZooDiscoveryContainerInstantiator()

### Method Detail

#### createInstance

    public IContainer createInstance​(ContainerTypeDescription description,
                                     Object[] parameters)

Description copied from interface: `IContainerInstantiator`
Create instance of IContainer. This is the interface that container provider implementations must implement for the containerFactory extension point. The caller may optionally specify both argument types and arguments that will be passed into this method (and therefore to the provider implementation implementing this method). For example:

ContainerFactory.getDefault().createContainer("foocontainer",new Object { "hello" });

Specified by:
  `createInstance` in interface `IContainerInstantiator`
Parameters:
  `description` - the ContainerTypeDescription associated with the registered container provider implementation
  `parameters` - parameters specified by the caller. May be null if no parameters are passed in by caller to ContainerFactory.getDefault().createContainer(...)
Returns:
  IContainer instance. The provider implementation must return a valid object implementing IContainer OR throw a ContainerCreateException. Null will not be returned.

#### getSupportedAdapterTypes

    public String[] getSupportedAdapterTypes​(ContainerTypeDescription description)

Description copied from interface: `IContainerInstantiator`
Get array of supported adapters for the given container type description. Providers implement this method to allow clients to inspect the adapter types exposed by the container described by the given description. The returned array entries will be the fully qualified names of the adapter classes. Note that the returned types do not guarantee that a subsequent call to `IContainer.getAdapter(Class)` with the same type name as a returned value will return a non-`null` result. In other words, even if the class name is in the returned array, subsequent calls to `IContainer.getAdapter(Class)` may still return `null`.

Specified by:
  `getSupportedAdapterTypes` in interface `IContainerInstantiator`
Parameters:
  `description` - the ContainerTypeDescription to report adapters for. Must not be `null`.
Returns:
  String[] of supported adapters. The entries in the returned array will be the fully qualified class names of adapters supported by the given description. `null` may be returned by the provider if no adapters are supported for this description.

#### getSupportedIntents

    public String[] getSupportedIntents​(ContainerTypeDescription description)

Specified by:
  `getSupportedIntents` in interface `IContainerInstantiator`

#### getSupportedParameterTypes

    public Class[][] getSupportedParameterTypes​(ContainerTypeDescription description)

Description copied from interface: `IContainerInstantiator`
Get array of parameter types for given container type description. Providers implement this method to allow clients to inspect the available set of parameter types understood for calls to `IContainerInstantiator.createInstance(ContainerTypeDescription, Object[])`.

Each of the rows of the returned array specifies a Class[] of parameter types. These parameter types correspond to the types of Object[] that can be passed into the second parameter of `IContainerInstantiator.createInstance(ContainerTypeDescription, Object[])`.

Consider the following example:

     public Class[][] getSupportedParameterTypes() {
            return new Class[][] { { String.class }, { String.class, String.class } };
     }

The above means that there are two acceptable values for the Object [] passed into `IContainerInstantiator.createInstance(ContainerTypeDescription, Object[])`: 1) a single String, and 2) two Strings. These would therefore be acceptable as input to createInstance:

     IContainer container = ContainerFactory.getDefault().createContainer(
                    description, new Object[] { "Hello" });

     IContainer container2 = ContainerFactory.getDefault().createContainer(
                    description, new Object[] { "Hello" });

Specified by:
  `getSupportedParameterTypes` in interface `IContainerInstantiator`
Parameters:
  `description` - the ContainerTypeDescription to return parameter types for
Returns:
  Class[][] array of Class[]s. Each row in the table corresponds to a Class[] that describes the types of Objects in Object[] for second parameter to `IContainerInstantiator.createInstance(ContainerTypeDescription, Object[])`. `null` returned if no parameter types supported for given description.